function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
import { MAXIMUM_FRACTION_DIGITS, MAXIMUM_NUMBER_DIGITS, NUMBER_DELIMITER } from '../constants/inputNumber.constants';

// input case 1: not formatted number string (on input change)
// input case 2: not formatted number (on blur)
// output: formatted number string with decimal char
export var formatNumber = function formatNumber(value, formatValue, notationThousandDelimiter, notationDecimalDelimiter, valueFormatOptions) {
  var _value$match, _value$match2;
  if (value === undefined || value === '' || value === null) {
    return '';
  }
  if (value === '-') {
    return '-';
  }
  var formatOptions = _extends({
    maximumFractionDigits: MAXIMUM_FRACTION_DIGITS
  }, valueFormatOptions);
  if (typeof value === 'number') {
    return formatValue(value, formatOptions);
  }
  var result = '';
  var lastChar = value == null ? void 0 : value.slice(-1);
  var numberResult = parseFloat(value);
  var notationDecimalChar = lastChar === NUMBER_DELIMITER ? notationDecimalDelimiter : '';
  var zerosAtTheEnd = (_value$match = value.match(new RegExp('0+$'))) == null ? void 0 : _value$match[0];
  var zerosWithDecimalDelimiterAtTheEnd = (_value$match2 = value.match(new RegExp("\\" + NUMBER_DELIMITER + "0+$"))) == null ? void 0 : _value$match2[0];
  var numberDelimiterExists = new RegExp("\\" + NUMBER_DELIMITER).test(value);
  if (Number.isNaN(numberResult)) {
    return '';
  }
  result = formatValue(numberResult, formatOptions);
  result = "" + result + notationDecimalChar;
  if (zerosWithDecimalDelimiterAtTheEnd) {
    result = "" + result + zerosWithDecimalDelimiterAtTheEnd;
  } else if (zerosAtTheEnd && numberDelimiterExists) {
    result = "" + result + zerosAtTheEnd;
  }
  return result;
};

// input: formatted number string
// output: not formatted number string with decimal char
export var parseFormattedNumber = function parseFormattedNumber(value, formatValue, notationThousandDelimiter, notationDecimalDelimiter) {
  if (value === undefined || value === '') {
    return '';
  }
  var result = value;
  result = result.split(notationThousandDelimiter).join('');
  if (result.length > MAXIMUM_NUMBER_DIGITS) {
    result = result.slice(0, MAXIMUM_NUMBER_DIGITS);
  }
  if (notationDecimalDelimiter !== NUMBER_DELIMITER) {
    result = result.replace(notationDecimalDelimiter, NUMBER_DELIMITER);
  }
  if ((result.match(new RegExp("\\" + NUMBER_DELIMITER, 'g')) || []).length > 1) {
    var lastDecimalDelimiterIndex = result.lastIndexOf(NUMBER_DELIMITER);
    result = result.slice(0, lastDecimalDelimiterIndex);
  }
  return result;
};